# This file was auto-generated by Fern from our API Definition.

from ...core.pydantic_utilities import UniversalBaseModel
import datetime as dt
import pydantic
from .ip_address_type import IpAddressType
import typing
from .load_balancer_state import LoadBalancerState
from .listener import Listener
from .target_group import TargetGroup
from ...core.pydantic_utilities import IS_PYDANTIC_V2


class LoadBalancerV2(UniversalBaseModel):
    """
    LoadBalancer represents a load balancer that distributes incoming network traffic across multiple servers.
    As defined by the AWS Go SDK (https://pkg.go.dev/github.com/aws/aws-sdk-go-v2/service/elasticloadbalancingv2@v1.33.1/types#LoadBalancer)
    """

    arn: str
    name: str
    region: str
    created_time: dt.datetime = pydantic.Field(alias="createdTime")
    dns_name: str = pydantic.Field(alias="dnsName")
    ip_address_type: IpAddressType = pydantic.Field(alias="ipAddressType")
    security_group_ids: typing.Optional[typing.List[str]] = pydantic.Field(alias="securityGroupIds", default=None)
    state: typing.Optional[LoadBalancerState] = None
    vpc_id: typing.Optional[str] = pydantic.Field(alias="vpcId", default=None)
    listeners: typing.Optional[typing.List[Listener]] = None
    subnet_ids: typing.Optional[typing.List[str]] = pydantic.Field(alias="subnetIds", default=None)
    hosted_zone_id: typing.Optional[str] = pydantic.Field(alias="hostedZoneId", default=None)
    target_groups: typing.Optional[typing.List[TargetGroup]] = pydantic.Field(alias="targetGroups", default=None)

    if IS_PYDANTIC_V2:
        model_config: typing.ClassVar[pydantic.ConfigDict] = pydantic.ConfigDict(extra="allow")  # type: ignore # Pydantic v2
    else:

        class Config:
            extra = pydantic.Extra.allow
